/*
FILE
	$Id: tjobfunc.h,v 1.14 2003/11/13 20:44:21 ggw Exp $
	(tAuthorize.cPasswd template set member)
PURPOSE

AUTHOR
	Template and mysqlRAD2 author: (c) 2001,2002 Gary Wallis.
	GPL License applies, see www.fsf.org for details

 
*/

int SubmitJob(char *cCommand, unsigned uNameServer, char *cZone,
				unsigned uPriority, unsigned uTime);
int SubmitSingleJob(char *cCommand,char *cZoneArg, unsigned uNameServerArg,
		char *cTargetServer, unsigned uPriorityArg, unsigned uTimeArg,
		unsigned *uMasterJob);
void tJobNavList(void);

void ExtProcesstJobVars(pentry entries[], int x)
{

	/*
	register int i;
	
	for(i=0;i<x;i++)
	{
	
	}
	*/

}//void ExtProcesstJobVars(pentry entries[], int x)


void ExttJobCommands(pentry entries[], int x)
{
	if(!strcmp(function,"tJobTools"))
	{
		//ModuleFunctionProcess()
		if(!strcmp(command,"Purge") && uPermLevel>9)
                {
			sprintf(query,"DELETE FROM tJob");
			mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
				mysqlBind(mysql_error(&mysql));
			tJob("Job queue purged");

		}

		//Default wizard like two step creation and deletion
		if(!strcmp(command,LANG_NB_NEW))
                {
	if(uPermLevel>=12)

			{
                        ProcesstJobVars(entries,x);
			//Check global conditions for new record here
                        mode=2000;
                        tJob(LANG_NB_CONFIRMNEW);
			}
                }
		else if(!strcmp(command,LANG_NB_CONFIRMNEW))
                {
	if(uPermLevel>=12)

			{
			
                        ProcesstJobVars(entries,x);
			//Check entries here
			uJob=0;
			uCreatedBy=uLoginClient;
			uOwner=uLoginClient;
			uModBy=0;//Never modified
			NewtJob(0);
			}
		}
		else if(!strcmp(command,LANG_NB_DELETE))
                {
                        ProcesstJobVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
		if( (uPermLevel>=12 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )

			{
                        mode=2001;
                        tJob(LANG_NB_CONFIRMDEL);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMDEL))
                {
                        ProcesstJobVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
		if( (uPermLevel>=12 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )

			{
                        mode=5;
                        DeletetJob();
			}
                }
		else if(!strcmp(command,LANG_NB_MODIFY))
                {
                        ProcesstJobVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
		if( (uPermLevel>=12 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )

			{
                        mode=2002;
                        tJob(LANG_NB_CONFIRMMOD);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMMOD))
                {
                        ProcesstJobVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
		if( (uPermLevel>=12 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )

			{
			uModBy=uLoginClient;
                        ModtJob();
			}
                }
	}

}//void ExttJobCommands(pentry entries[], int x)


void ExttJobButtons(void)
{
	time_t luTime;

	printf("<table width=260 border=0 bgcolor=#9BC1B3 valign=center>\n");
        printf("<tr><td>");

	printf("<font face=Arial,Helvetica>");
	printf("<font size=2>");
	if(uTime)
	{
		luTime=uTime;
		printf("%s<br>",ctime(&luTime));
	}

	switch(mode)
        {
                case 2000:
			printf("Enter required data<br>");
                        printf("<font size=1>");
                        printf(LANG_NBB_CONFIRMNEW);
			printf("<br>\n");
                break;

                case 2001:
                        printf("<font size=1>");
                        printf(LANG_NBB_CONFIRMDEL);
			printf("<br>\n");
                break;

                case 2002:
			printf("Review record data<br>");
                        printf("<font size=1>");
                        printf(LANG_NBB_CONFIRMMOD);
			printf("<br>\n");
                break;
	}

	printf("<font size=1>");
	if(uPermLevel>9)
	{	
		printf("<hr>");
		printf("<input class=largeButton type=submit name=command value=Purge>");
	}

	printf("<font size=2>");
        printf("<p><u>tJobNavList</u><br>\n");
	tJobNavList();

        printf("</td></tr>\n");
        printf("</table>\n");

}//void ExttJobButtons(void)


void ExttJobAuxTable(void)
{

}//void ExttJobAuxTable(void)


void ExttJobGetHook(entry gentries[], int x)
{
	register int i;

	for(i=0;i<x;i++)
	{
		if(!strcmp(gentries[i].name,"uJob"))
		{
			sscanf(gentries[i].val,"%u",&uJob);
			mode=6;
		}
	}
	tJob("");

}//void ExttJobGetHook(entry gentries[], int x)


void ExttJobSelect(void)
{
        //Set non search query here for tTableName()
	if(uPermLevel>=9)
	sprintf(query,"SELECT %s FROM tJob ORDER BY uJob",VAR_LIST_tJob);
	else
	sprintf(query,"SELECT %s FROM tJob,tClient\
                                WHERE tJob.uOwner=tClient.uClient\
                                AND (tClient.uOwner=%u OR tClient.uClient=%u)\
				ORDER BY uJob",
					VAR_LIST_tJob,uLoginClient,uLoginClient);

}//void ExttJobSelect(void)


void ExttJobSelectRow(void)
{
	if(uPermLevel<10)
                sprintf(query,"SELECT %s FROM tJob,tClient \
                                WHERE tJob.uOwner=tClient.uClient\
                                AND (tClient.uOwner=%u OR tClient.uClient=%u)\
                                AND tJob.uJob=%u",
                        		VAR_LIST_tJob,
					uLoginClient,uLoginClient,uJob);
	else
                sprintf(query,"SELECT %s FROM tJob WHERE uJob=%u",
			VAR_LIST_tJob,uJob);

}//void ExttJobSelectRow(void)


void ExttJobListSelect(void)
{
	char cCat[512];

	if(uPermLevel<10)
		sprintf(query,"SELECT %s FROM tJob,tClient \
		WHERE tJob.uOwner=tClient.uClient \
		AND (tClient.uOwner=%u OR tClient.uClient=%u)",
				VAR_LIST_tJob,
				uLoginClient,
				uLoginClient);
	else
                sprintf(query,"SELECT %s FROM tJob",
				VAR_LIST_tJob);

	//Changes here must be reflected below in ExttJobListFilter()
        if(!strcmp(filter,"uJob"))
        {
                sscanf(command,"%u",&uJob);
		if(uPermLevel<10)
			strcat(query," AND ");
		else
			strcat(query," WHERE ");
		sprintf(cCat,"tJob.uJob=%u \
						ORDER BY uJob",
						uJob);
		strcat(query,cCat);
        }
        else if(1)
        {
                //None NO FILTER
                strcpy(filter,"None");
		strcat(query," ORDER BY uJob");
        }

}//void ExttJobListSelect(void)


void ExttJobListFilter(void)
{
        //Filter
        printf("<td align=right >Select ");
        printf("<select name=filter>");
        if(strcmp(filter,"uJob"))
                printf("<option>uJob</option>");
        else
                printf("<option selected>uJob</option>");
        if(strcmp(filter,"None"))
                printf("<option>None</option>");
        else
                printf("<option selected>None</option>");
        printf("</select>");

}//void ExttJobListFilter(void)


void ExttJobNavBar(void)
{
	if(uOwner) GetClientOwner(uOwner,&uReseller);

	printf(LANG_NBB_SKIPFIRST);
	printf(LANG_NBB_SKIPBACK);
	printf(LANG_NBB_SEARCH);

	if(uPermLevel>=12)

	printf(LANG_NBB_NEW);
	//printf(LANG_NBB_NEWREV);

		if( (uPermLevel>=12 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )

	printf(LANG_NBB_MODIFY);

		if( (uPermLevel>=12 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )

	printf(LANG_NBB_DELETE);

	printf(LANG_NBB_LIST);

	printf(LANG_NBB_SKIPNEXT);
	printf(LANG_NBB_SKIPLAST);

}//void ExttJobNavBar(void)


int SubmitJob(char *cCommand, unsigned uNameServerArg, char *cZoneArg,
				unsigned uPriorityArg, unsigned uTimeArg)
{
	MYSQL_RES *res2;
	MYSQL_ROW field;
	static unsigned uMasterJob=0;

	//Submit one job per EACH NS in the list, group with
	//uMasterJob
	sprintf(query,"SELECT cList FROM tNameServer WHERE uNameServer=%u",
			uNameServerArg);

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res2=mysql_store_result(&mysql);
	
	if((field=mysql_fetch_row(res2)))
	{
		register int i,j=0;

		for(i=0;i<strlen(field[0]);i++)
		{
			if(field[0][i]!='\n' && field[0][i])
			{
				cTargetServer[j++]=field[0][i];
			}
			else
			{
				cTargetServer[j]=0;
				j=0;

if(SubmitSingleJob(cCommand,cZoneArg,uNameServerArg,cTargetServer,uPriorityArg,uTimeArg,&uMasterJob))
	mysqlBind(mysql_error(&mysql));

			}//if else

		}//for

	}//if field
	mysql_free_result(res2);

	return(0);
	return(1);

}//int SubmitJob()


int SubmitSingleJob(char *cCommand,char *cZoneArg, unsigned uNameServerArg,
		char *cTargetServer, unsigned uPriorityArg, unsigned uTimeArg
	       			,unsigned *uMasterJob)
{
	MYSQL_RES *res;
	

	//Don't submit equivalent jobs: Study this issue further:
	//uPriority uTime issues?
	//Have job queue processor handle wierd things like?
	sprintf(query,"SELECT uJob FROM tJob WHERE cJob='%s' AND cZone='%s' AND uNameServer=%u AND cTargetServer='%s'",cCommand,cZoneArg,uNameServerArg,cTargetServer);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	
	if(mysql_num_rows(res)==0)
	{
		uJob=0;//auto increment
		strcpy(cJob,cCommand);
		strcpy(cZone,cZoneArg);
		uNameServer=uNameServerArg;
		uPriority=uPriorityArg;
		uTime=uTimeArg;
		uCreatedBy=uLoginClient;
		uOwner=uLoginClient;
		Insert_tJob();
		if(mysql_error(&mysql)[0])
		{
			mysql_free_result(res);
			return(1);
		}

		if(*uMasterJob == 0)
		{
			uJob=*uMasterJob=mysql_insert_id(&mysql);
			if(!strstr(cTargetServer,"MASTER"))
				tNameServer("MASTER must be first in cList");
		}
		else
		{
			uJob=mysql_insert_id(&mysql);
		}
	
		sprintf(query,"UPDATE tJob SET uMasterJob=%u WHERE uJob=%u",*uMasterJob,uJob);
		mysql_query(&mysql,query);
		if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
		if(mysql_affected_rows(&mysql)==0)
		{
			//debug only
			sprintf(query,"uMasterJob %u",*uMasterJob);
			tJob(query);
		}
	}
	mysql_free_result(res);



	return(0);
}//int SubmitSingleJob()


void tJobNavList(void)
{
        MYSQL_RES *res;
        MYSQL_ROW field;

	if(uPermLevel<10)
		sprintf(query,"SELECT tJob.uJob\
				,tJob.cJob\
				FROM tJob,tClient\
                                WHERE tJob.uOwner=tClient.uClient\
                                AND (tClient.uOwner=%u OR tClient.uClient=%u)",
					uLoginClient,uLoginClient);
	else
	        sprintf(query,"SELECT uJob,cJob FROM tJob");

        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
        {
                printf("%s",mysql_error(&mysql));
                return;
        }

        res=mysql_store_result(&mysql);
        while((field=mysql_fetch_row(res)))
        {
                printf("<a class=darkLink href=mysqlBind.cgi?function=tJob\
&uJob=%s>%s</a><br>\n",field[0],field[1]);
        }
        mysql_free_result(res);

}//void tJobNavList(void)


